config/routes.rb
Rails.application.routes.draw do
	root to: "pages#index"

	get "first", to: "pages#first"
	get "second", to: "pages#second"
	get "third", to: "pages#third"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Demorama</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/pages/first.html.erb
<div class="panorama">
	<%= image_tag("promenada.jpg") %>
</div>

<script>
	// Use $(window).load() on live site instead of document ready. This is for the purpose of running locally only
  $(document).ready(function(){
     $(".panorama").panorama_viewer({
       repeat: true
     });
	});
</script>

app/views/pages/index.html.erb
<h1> Demorama </h1>
<p> Few examples of 360° panorama images presented with JavaScript libraries. </p>

<ul>
	<li> <%= link_to "First", first_path %> </li>
	<li> <%= link_to "Second", second_path %> </li>
	<li> <%= link_to "Third", third_path %> </li>
</ul>

app/views/pages/second.html.erb
<div id="container"></div>

<script>
	var camera, scene, renderer;

	var isUserInteracting = false,
	onMouseDownMouseX = 0, onMouseDownMouseY = 0,
	lon = 0, onMouseDownLon = 0,
	lat = 0, onMouseDownLat = 0,
	phi = 0, theta = 0;

	init();
	animate();

	function init() {
		var container, mesh;

		container = document.getElementById( 'container' );

		camera = new THREE.PerspectiveCamera( 75, window.innerWidth / window.innerHeight, 1, 1100 );
		camera.target = new THREE.Vector3( 0, 0, 0 );

		scene = new THREE.Scene();

		var geometry = new THREE.SphereGeometry( 500, 60, 40 );
		geometry.scale( - 1, 1, 1 );

		var material = new THREE.MeshBasicMaterial( {
			map: new THREE.TextureLoader().load( '<%= image_url("hotel_os.jpg") %>' ),
		} );
		mesh = new THREE.Mesh( geometry, material );

		scene.add( mesh );

		renderer = new THREE.WebGLRenderer();
		renderer.setPixelRatio( window.devicePixelRatio );
		renderer.setSize( window.innerWidth, window.innerHeight );
		container.appendChild( renderer.domElement );

		document.addEventListener( 'mousedown', onDocumentMouseDown, false );
		document.addEventListener( 'mousemove', onDocumentMouseMove, false );
		document.addEventListener( 'mouseup', onDocumentMouseUp, false );
		document.addEventListener( 'mousewheel', onDocumentMouseWheel, false );
		document.addEventListener( 'MozMousePixelScroll', onDocumentMouseWheel, false);

		document.addEventListener( 'dragover', function ( event ) {
			event.preventDefault();
			event.dataTransfer.dropEffect = 'copy';
		}, false );

		document.addEventListener( 'dragenter', function ( event ) {
			document.body.style.opacity = 0.5;
		}, false );

		document.addEventListener( 'dragleave', function ( event ) {
			document.body.style.opacity = 1;
		}, false );

		document.addEventListener( 'drop', function ( event ) {
			event.preventDefault();
			var reader = new FileReader();
			reader.addEventListener( 'load', function ( event ) {
				material.map.image.src = event.target.result;
				material.map.needsUpdate = true;
			}, false );
			reader.readAsDataURL( event.dataTransfer.files[ 0 ] );
			document.body.style.opacity = 1;
		}, false );

		window.addEventListener( 'resize', onWindowResize, false );

	}

	function onWindowResize() {
		camera.aspect = window.innerWidth / window.innerHeight;
		camera.updateProjectionMatrix();
		renderer.setSize( window.innerWidth, window.innerHeight );
	}

	function onDocumentMouseDown( event ) {
		event.preventDefault();
		isUserInteracting = true;
		onPointerDownPointerX = event.clientX;
		onPointerDownPointerY = event.clientY;
		onPointerDownLon = lon;
		onPointerDownLat = lat;
	}

	function onDocumentMouseMove( event ) {
		if ( isUserInteracting === true ) {
			lon = ( onPointerDownPointerX - event.clientX ) * 0.1 + onPointerDownLon;
			lat = ( event.clientY - onPointerDownPointerY ) * 0.1 + onPointerDownLat;
		}
	}

	function onDocumentMouseUp( event ) {
		isUserInteracting = false;
	}

	function onDocumentMouseWheel( event ) {
		// WebKit
		if ( event.wheelDeltaY ) {
			camera.fov -= event.wheelDeltaY * 0.05;
		// Opera / Explorer 9
		} else if ( event.wheelDelta ) {
			camera.fov -= event.wheelDelta * 0.05;
		// Firefox
		} else if ( event.detail ) {
			camera.fov += event.detail * 1.0;
		}
			camera.updateProjectionMatrix();
		}

	function animate() {
		requestAnimationFrame( animate );
		update();
	}
	function update() {
		if ( isUserInteracting === false ) {
			lon += 0.1;
		}
		lat = Math.max( - 85, Math.min( 85, lat ) );
		phi = THREE.Math.degToRad( 90 - lat );
		theta = THREE.Math.degToRad( lon );
		camera.target.x = 500 * Math.sin( phi ) * Math.cos( theta );
		camera.target.y = 500 * Math.cos( phi );
		camera.target.z = 500 * Math.sin( phi ) * Math.sin( theta );
		camera.lookAt( camera.target );
		renderer.render( scene, camera );
	}
</script>

app/views/pages/third.html.erb
<div id="container"></div>

<script>
	var camera, scene, renderer;

	var isUserInteracting = false,
	onMouseDownMouseX = 0, onMouseDownMouseY = 0,
	lon = 0, onMouseDownLon = 0,
	lat = 0, onMouseDownLat = 0,
	phi = 0, theta = 0;

	init();
	animate();

	function init() {
		var container, mesh;

		container = document.getElementById( 'container' );

		camera = new THREE.PerspectiveCamera( 75, window.innerWidth / window.innerHeight, 1, 1100 );
		camera.target = new THREE.Vector3( 0, 0, 0 );

		scene = new THREE.Scene();

		var geometry = new THREE.SphereGeometry( 500, 60, 40 );
		geometry.scale( - 1, 1, 1 );

		var material = new THREE.MeshBasicMaterial( {
			map: new THREE.TextureLoader().load( '<%= image_url("hotel_os.jpg") %>' ),
		} );
		mesh = new THREE.Mesh( geometry, material );

		var pin = THREE.ImageUtils.loadTexture( '<%= image_url("exit.png") %>' );

		var marker = new THREE.SpriteMaterial( { map: pin } );
		var sprite = new THREE.Sprite( marker );
		sprite.name = "exit";
		sprite.position.set( -50, 2, 50 );
		sprite.scale.set(20, 20, 1 );

	  group = new THREE.Object3D;
    group.add(sprite);

		scene.add(group);
		scene.add( mesh );

		renderer = new THREE.WebGLRenderer();
		renderer.setPixelRatio( window.devicePixelRatio );
		renderer.setSize( window.innerWidth, window.innerHeight );
		container.appendChild( renderer.domElement );

		document.addEventListener( 'mousedown', onDocumentMouseDown, false );
		document.addEventListener( 'mousemove', onDocumentMouseMove, false );
		document.addEventListener( 'mouseup', onDocumentMouseUp, false );
		document.addEventListener( 'mousewheel', onDocumentMouseWheel, false );
		document.addEventListener( 'MozMousePixelScroll', onDocumentMouseWheel, false);

		var raycaster = new THREE.Raycaster();
		var mouse = new THREE.Vector2();
		document.addEventListener( 'click', function ( event ) {
			event.preventDefault();

  	  mouse.x = ( event.clientX / renderer.domElement.clientWidth ) * 2 - 1;
	    mouse.y = - ( event.clientY / renderer.domElement.clientHeight ) * 2 + 1;

			raycaster.setFromCamera( mouse, camera );

			var intersects = raycaster.intersectObjects( scene.children, true ); 

			for ( var i = 0; i < intersects.length; i++ ) {
				if (intersects[i].object.name=="exit") {
					mesh.material.map = THREE.ImageUtils.loadTexture( '<%= image_url("promenada2.jpg") %>' );
					mesh.material.needsUpdate = true;
				}
			}
		}, false );

		document.addEventListener( 'dragover', function ( event ) {
			event.preventDefault();
			event.dataTransfer.dropEffect = 'copy';
		}, false );

		document.addEventListener( 'dragenter', function ( event ) {
			document.body.style.opacity = 0.5;
		}, false );

		document.addEventListener( 'dragleave', function ( event ) {
			document.body.style.opacity = 1;
		}, false );

		document.addEventListener( 'drop', function ( event ) {
			event.preventDefault();
			var reader = new FileReader();
			reader.addEventListener( 'load', function ( event ) {
				material.map.image.src = event.target.result;
				material.map.needsUpdate = true;
			}, false );
			reader.readAsDataURL( event.dataTransfer.files[ 0 ] );
			document.body.style.opacity = 1;
		}, false );

		window.addEventListener( 'resize', onWindowResize, false );

	}

	function onWindowResize() {
		camera.aspect = window.innerWidth / window.innerHeight;
		camera.updateProjectionMatrix();
		renderer.setSize( window.innerWidth, window.innerHeight );
	}

	function onDocumentMouseDown( event ) {
		event.preventDefault();
		isUserInteracting = true;
		onPointerDownPointerX = event.clientX;
		onPointerDownPointerY = event.clientY;
		onPointerDownLon = lon;
		onPointerDownLat = lat;
	}

	function onDocumentMouseMove( event ) {
		if ( isUserInteracting === true ) {
			lon = ( onPointerDownPointerX - event.clientX ) * 0.1 + onPointerDownLon;
			lat = ( event.clientY - onPointerDownPointerY ) * 0.1 + onPointerDownLat;
		}
	}

	function onDocumentMouseUp( event ) {
		isUserInteracting = false;
	}

	function onDocumentMouseWheel( event ) {
		// WebKit
		if ( event.wheelDeltaY ) {
			camera.fov -= event.wheelDeltaY * 0.05;
		// Opera / Explorer 9
		} else if ( event.wheelDelta ) {
			camera.fov -= event.wheelDelta * 0.05;
		// Firefox
		} else if ( event.detail ) {
			camera.fov += event.detail * 1.0;
		}
			camera.updateProjectionMatrix();
		}

	function animate() {
		requestAnimationFrame( animate );
		update();
	}
	function update() {
		if ( isUserInteracting === false ) {
			//lon += 0.1;
		}
		lat = Math.max( - 85, Math.min( 85, lat ) );
		phi = THREE.Math.degToRad( 90 - lat );
		theta = THREE.Math.degToRad( lon );
		camera.target.x = 500 * Math.sin( phi ) * Math.cos( theta );
		camera.target.y = 500 * Math.cos( phi );
		camera.target.z = 500 * Math.sin( phi ) * Math.sin( theta );
		camera.lookAt( camera.target );
		renderer.render( scene, camera );
	}
</script>